#ifndef _C_PM_SOCKET_H_
#define _C_PM_SOCKET_H_

#include <stdint.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define PMSOCKET_ERROR -1
#ifndef _PM_BYTE_TYPE_
#define _PM_BYTE_TYPE_
	typedef unsigned char byte;
#endif

	typedef enum {TCP, UDP} transport;

typedef struct {
	int socketFD;
	struct sockaddr_in addr;
	transport trans;
} PMSocket;

PMSocket *pmsocket_open(const char *address, uint16_t port, transport trans);
PMSocket *pmsocket_connect(const char *address, uint16_t port);
PMSocket *pmsocket_accept(PMSocket *pmSocket, int queue);
int pmsocket_close(PMSocket *pmSocket);
int pmsocket_send(const PMSocket *pmSocket, const byte *data, uint32_t length);
PMSocket *pmsocket_recv(const PMSocket *pmSocket, byte *data, uint32_t length, PMSocket *sender);


#endif
