#ifndef ARRAY_TYPE_H
#define ARRAY_TYPE_H

#include "type.h"

class ArrayType : public Type {
	private:
		Type *type;
		int size;

	public:
		ArrayType(SrcPosition *position, types typeCode, Type *type, int size)
				: Type(position, typeCode), type(type), size(size) {}

		ArrayType(const ArrayType& arrayType) : Type(arrayType.position, arrayType.typeCode) {
			*(this) = arrayType;
		}

		virtual ~ArrayType() {
			delete this->type;
		}

		Type *getType() {
			return this->type;
		}

		int getSize() const {
			return this->size;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitArrayType(this);
		}

		virtual Ast& clone() const {
			return *(new ArrayType(new SrcPosition(*(this->position)),
					 this->typeCode,
					 this->type ? dynamic_cast<Type*>(&(this->type->clone())) : 0,
					 this->size));
		}
};

#endif
