#ifndef ASSIGN_STATEMENT_H
#define ASSIGN_STATEMENT_H

#include "simplestatement.h"
#include "leftsidelist.h"
#include "expressionlist.h"

class AssignStatement : public SimpleStatement {
	private:
		LeftSideList *leftSideList;
		ExpressionList *expressionList;

	public:
		AssignStatement(SrcPosition *position, LeftSideList *leftSideList, ExpressionList *expressionList)
				: SimpleStatement(position), leftSideList(leftSideList), expressionList(expressionList) {}

		AssignStatement(const AssignStatement& assignStatement) : SimpleStatement(assignStatement.position) {
			*(this) = assignStatement;
		}

		virtual ~AssignStatement() {
			delete this->leftSideList;
			delete this->expressionList;
		}

		LeftSideList *getLeftSideList() {
			return this->leftSideList;
		}

		ExpressionList *getExpressionList() {
			return this->expressionList;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitAssignStatement(this);
		}

		virtual Ast& clone() const {
			return *(new AssignStatement(new SrcPosition(*(this->position)),
					 this->leftSideList ? dynamic_cast<LeftSideList*>(&(this->leftSideList->clone())) : 0,
					 this->expressionList ? dynamic_cast<ExpressionList*>(&(this->expressionList->clone())) : 0));
		}
};

#endif
