#include <typeinfo>
#include "binaryexpression.h"
using namespace std;

Ast& BinaryExpression::operator = (const Ast& ast) {
	const BinaryExpression& binaryExpression = dynamic_cast<const BinaryExpression&>(ast);

	Expression::operator=(ast);
	this->leftExpression = binaryExpression.leftExpression ? dynamic_cast<Expression*>(&(binaryExpression.leftExpression->clone())) : 0;
	this->rightExpression = binaryExpression.rightExpression ? dynamic_cast<Expression*>(&(binaryExpression.rightExpression->clone())) : 0;
	this->op = binaryExpression.op;

	return *(this);
}

bool BinaryExpression::operator == (const Ast& ast) const {
	bool result = false;
	const BinaryExpression& binaryExpression = dynamic_cast<const BinaryExpression&>(ast);

	if (typeid(ast) != typeid(BinaryExpression))
		return false;

	if (this->leftExpression && this->rightExpression)
		result = (*(this->leftExpression) == *(binaryExpression.leftExpression)) &&
			 (*(this->rightExpression) == *(binaryExpression.rightExpression));

	return result && (this->op == binaryExpression.op) && Expression::operator==(ast);
}

