#!/usr/bin/perl

$uso = "\nUso: createClass <ClassName> [atributos...]\n\n";

die($uso) if ($#ARGV < 0);

@nomes = split(/(?=[A-Z])/, $ARGV[0]);
$class = $ARGV[0];
shift(@ARGV);

$define = join("_", @nomes) . "_H";

$isSimpleSequential = 0;
$isSimpleSequential = 1 if ($nomes[0] eq "Simple");
$isSimpleSequential = 2 if ($nomes[0] eq "Sequential");
$stripedName = "";

if ($isSimpleSequential)
{ 	@temp = @nomes;
	shift(@temp);
	$stripedName = join("", @temp);
}

&generateHeader;
&generateCPP;
print "Classes geradas!\n";

exit;


sub generateHeader
{
    print "Gerando \L$class.h\n";
	open(OUT,">\L$class.h") or die("No foi possvel criar o arquivo \L$class.h\n");

### Defines
	print OUT "#ifndef \U$define\n";
	print OUT "#define \U$define\n\n";
	
### Includes
	if (!$isSimpleSequential)
		{ print OUT "#include \"ast.h\"\n";}
	else
		{ print OUT "\L#include \"$stripedName.h\"\n"; }

	if ($isSimpleSequential == 2)
		{ print OUT "\L#include \"simple$stripedName.h\"\n" if ($isSimpleSequential == 2); }
	
	else
	{
		foreach $atribute (@ARGV)
			{ print OUT "\L#include \"$atribute\.h\"\n"; }
	}

### Classe
	print OUT "\nclass $class : public ";

	if ($isSimpleSequential)
		{ print OUT "$stripedName {\n"; }
	else
		{ print OUT "Ast {\n"; }

### Atributos
	print OUT "\tprivate:\n";
	if ($isSimpleSequential == 2)
	{
		print OUT "\t\t$stripedName *\l$stripedName;\n";
		print OUT "\t\tSimple$stripedName *simple$stripedName;\n\n";
	}
	else
	{
		foreach $atribute (@ARGV)
			{ print OUT "\t\t\u$atribute *$atribute;\n"; }
	}

### Mtodos
	print OUT "\n\tpublic:\n";

### Construtor
	print OUT "\t\t$class(SrcPosition *position";

	if ($isSimpleSequential == 2)
	{
		print OUT ", $stripedName *\l$stripedName, Simple$stripedName *simple$stripedName)\n";
		print OUT "\t\t\t: $stripedName(position), \l$stripedName(\l$stripedName), simple$stripedName(simple$stripedName) {}\n\n";
	}
	else
	{
		foreach $atribute (@ARGV)
			{ print OUT ", \u$atribute *$atribute"; }
		if ($isSimpleSequential)
			{ print OUT ")\n\t\t\t: $stripedName(position)"; }
		else
			{ print OUT ")\n\t\t\t\t: Ast(position)";}

		foreach $atribute (@ARGV)
			{ print OUT ", $atribute($atribute)"; }
		print OUT " {}\n\n";
	}

### Construtor de cpia
	if ($#ARGV > -1 || $isSimpleSequential == 2)
	{
		print OUT "\t\t$class(const $class\& \l$class) : ";
		if ($isSimpleSequential)
			{ print OUT "$stripedName(\l$class.position) {\n"; }
		else
			{ print OUT "Ast(\l$class.position) {\n";}
			
        print OUT "\t\t\t*(this) = \l$class;\n";
        print OUT "\t\t}\n\n";
	}

### Destrutor
	if ($isSimpleSequential == 2)
	{
		print OUT "\t\tvirtual \~$class() {\n";
		print OUT "\t\t\tdelete this->\l$stripedName;\n";
		print OUT "\t\t\tdelete this->simple$stripedName;\n";
		print OUT "\t\t}\n\n";
	}
	else
	{
		print OUT "\t\tvirtual \~$class() {\n";
		foreach $atribute (@ARGV)
			{ print OUT "\t\t\tdelete this->$atribute;\n"; }
		print OUT "\t\t}\n\n";
		
####### Mtodos get
		foreach $atribute (@ARGV)
		{
			print OUT "\t\t\u$atribute *get\u$atribute() {\n";
			print OUT "\t\t\treturn this->$atribute;\n";
			print OUT "\t\t}\n\n";
		}
	}

### Mtodos get do sequential
	if ($isSimpleSequential == 2)
	{
		print OUT "\t\t$stripedName *get$stripedName() {\n";
		print OUT "\t\t\treturn this->\l$stripedName;\n";
		print OUT "\t\t}\n\n";
		
		print OUT "\t\tSimple$stripedName *getSimple$stripedName() {\n";
		print OUT "\t\t\treturn this->simple$stripedName;\n";
		print OUT "\t\t}\n\n";
	}

### Operadores, clone e visitor
	if ($#ARGV > -1 || $isSimpleSequential == 2)
	{
		print OUT "\t\tvirtual Ast& operator = (const Ast& ast);\n";
		print OUT "\t\tvirtual bool operator == (const Ast& ast) const;\n\n";

		print OUT "\t\tvirtual VisitorReturn *visit(Visitor& visitor) {\n";
        print OUT "\t\t\treturn visitor.visit$class(this);\n";
        print OUT "\t\t}\n\n";

		print OUT "\t\tvirtual Ast& clone() const {\n";
        print OUT "\t\t\treturn *(new $class(new SrcPosition(*(this->position))";
		if ($isSimpleSequential == 2)
		{
			print OUT ",\n\t\t\t\t\t this->\l$stripedName ? dynamic_cast<$stripedName*>(&(this->\l$stripedName->clone())) : 0,\n";
			print OUT "\t\t\t\t\t this->simple$stripedName ? dynamic_cast<Simple$stripedName*>(&(this->simple$stripedName->clone())) : 0";
		}
		else
		{
			foreach $atribute (@ARGV)
				{ print OUT ",\n\t\t\t\t\t this->$atribute ? dynamic_cast<\u$atribute*>(&(this->$atribute->clone())) : 0"; }
		}
		
		print OUT "));\n";
        print OUT "\t\t}\n";
	}
	else
	{
		print OUT "\t\tvirtual Ast& operator = (const Ast& ast) {\n";
		print OUT "\t\t\tAst::operator=(ast);\n";
		print OUT "\t\t\treturn *(this);\n";
		print OUT "\t\t}\n";

		print OUT "\t\tvirtual bool operator == (const Ast& ast) const {\n";
		print OUT "\t\t\treturn Ast::operator==(ast);\n";
		print OUT "\t\t}\n";
	}

	print OUT "};\n\n#endif\n";

	close(OUT);
    print "\L$class.h gerado!\n\n";
}

sub generateCPP
{
    if ($#ARGV > -1 || $isSimpleSequential == 2)
    {
        print "Gerando \L$class.cpp...\n";
        open(OUT, ">\L$class.cpp") or die("No foi possvel criar \L$class.cpp!\n");

####### Includes
		print OUT "#include <typeinfo>\n";
		print OUT "\L#include \"$class.h\"\n";
		print OUT "using namespace std;\n\n";

####### Operador =
		print OUT "Ast& $class\:\:operator = (const Ast& ast) {\n";
        print OUT "\tconst $class\& \l$class = dynamic_cast<const $class\&>(ast);\n\n";

		if ($isSimpleSequential)
			{ print OUT "\t$stripedName\:\:operator=(ast);\n";}
		else
			{ print OUT "\tAst\:\:operator=(ast);\n"}
			
		if ($isSimpleSequential == 2)
        {
            print OUT "\tthis->\l$stripedName = \l$class.\l$stripedName ? dynamic_cast<$stripedName*>".
                      "(&(\l$class.\l$stripedName->clone())) : 0;\n";

            print OUT "\tthis->simple$stripedName = \l$class.simple$stripedName ? dynamic_cast<Simple$stripedName*>".
                      "(&(\l$class.simple$stripedName->clone())) : 0;\n";
        }
		else
		{
			foreach $atribute (@ARGV)
			{
				print OUT "\tthis->$atribute = \l$class.$atribute ? dynamic_cast<\u$atribute*>".
						  "(&(\l$class.$atribute->clone())) : 0;\n";
			}
		}

        print OUT "\n\treturn *(this);\n";
        print OUT "}\n\n";

####### Operador ==
		print OUT "bool $class\:\:operator == (const Ast& ast) const {\n";
        print OUT "\tbool result = false;\n";
        print OUT "\tconst $class\& \l$class = dynamic_cast<const $class\&>(ast);\n\n";
		print OUT "\tif (typeid(ast) != typeid($class))\n";
		print OUT "\t\treturn false;\n\n";
		
		if ($isSimpleSequential == 2)
        {
            print OUT "\tif (this->\l$stripedName && this->simple$stripedName)\n";
            print OUT "\t\tresult = (*(this->\l$stripedName) == *(\l$class.\l$stripedName) &&\n" .
                      "\t\t\t\t  *(this->\lsimple$stripedName) == *(\l$class.simple$stripedName));\n";
        }
		else
		{
			print OUT "\tif (";
			$i = 0;
			foreach $atribute (@ARGV)
			{
				print OUT "this->$atribute";
				if ($i < $#ARGV)
					{ print OUT " && ";}
				$i++;
			}
			print OUT ")\n";

			print OUT "\t\tresult = (";
			$i = 0;
			foreach $atribute (@ARGV)
			{
				if ($i == 0)
					{ print OUT "*(this->$atribute) == *(\l$class.$atribute)"; }
				else
					{ print OUT "\t\t\t\t   *(this->$atribute) == *(\l$class.$atribute)"; }
				if ($i < $#ARGV)
					{ print OUT " &&\n"}
				$i++;
			}
			print OUT ");\n";
		}
		
        print OUT "\n\treturn result";
		if ($isSimpleSequential)
			{ print OUT " && $stripedName\:\:operator==(ast)";}
		else
			{ print OUY " && Ast\:\:operator==(ast)";}
		print OUT ";\n";
        print OUT "}\n\n";

        close(OUT);
        print "\L$class.cpp gerado!\n\n";        
    }
}
