#ifndef DO_STATEMENT_H
#define DO_STATEMENT_H

#include "simplestatement.h"
#include "guardedstatement.h"

class DoStatement : public SimpleStatement {
	private:
		GuardedStatement *guardedStatement;

	public:
		DoStatement(SrcPosition *position, GuardedStatement *guardedStatement)
				: SimpleStatement(position), guardedStatement(guardedStatement) {}

		DoStatement(const DoStatement& doStatement) : SimpleStatement(doStatement.position) {
			*(this) = doStatement;
		}

		virtual ~DoStatement() {
			delete this->guardedStatement;
		}

		GuardedStatement *getGuardedStatement() {
			return this->guardedStatement;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitDoStatement(this);
		}

		virtual Ast& clone() const {
			return *(new DoStatement(new SrcPosition(*(this->position)),
					 this->guardedStatement ? dynamic_cast<GuardedStatement*>(&(this->guardedStatement->clone())) : 0));
		}
};

#endif
