#ifndef GUARD_EXPRESSION_H
#define GUARD_EXPRESSION_H

#include "guard.h"
#include "expression.h"

class GuardExpression : public Guard {
	private:
		Expression *expression;

	public:
		GuardExpression(SrcPosition *position, Expression *expression)
				: Guard(position), expression(expression) {}

		GuardExpression(const GuardExpression& guardExpression) : Guard(guardExpression.position) {
			*(this) = guardExpression;
		}

		virtual ~GuardExpression() {
			delete this->expression;
		}

		Expression *getExpression() {
			return this->expression;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitGuardExpression(this);
		}

		virtual Ast& clone() const {
			return *(new GuardExpression(new SrcPosition(*(this->position)),
					 this->expression ? dynamic_cast<Expression*>(&(this->expression->clone())) : 0));
		}
};

#endif
