#ifndef GUARD_TIMEOUT_H
#define GUARD_TIMEOUT_H

#include "guard.h"
#include "identifier.h"

class GuardTimeout : public Guard {
	private:
		Identifier *identifier;

	public:
		GuardTimeout(SrcPosition *position, Identifier *identifier)
				: Guard(position), identifier(identifier) {}

		GuardTimeout(const GuardTimeout& guardTimeout) : Guard(guardTimeout.position) {
			*(this) = guardTimeout;
		}

		virtual ~GuardTimeout() {
			delete this->identifier;
		}

		Identifier *getIdentifier() {
			return this->identifier;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitGuardTimeout(this);
		}

		virtual Ast& clone() const {
			return *(new GuardTimeout(new SrcPosition(*(this->position)),
					 this->identifier ? dynamic_cast<Identifier*>(&(this->identifier->clone())) : 0));
		}
};

#endif
