#ifndef IDENTIFIER_H
#define IDENTIFIER_H
#include "ast.h"
#include <string>
#include "leftside.h"
#include "expression.h"

using namespace std;

class Identifier : public Expression, public LeftSide {
	private:
		string name;
	public:
		Identifier(SrcPosition *position, string name) : Expression(position), LeftSide(position), Ast(position), name(name) {}
		Identifier(const Identifier& identifier) : Expression(identifier.position), LeftSide(identifier.position), Ast(position) {
			*(this) = identifier;
		}
		
		virtual ~Identifier() {}
		
		string getName() const {
			return this->name;
		}
		
		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitIdentifier(this);
		}
		
		virtual Ast& clone() const {
			return *(new Identifier(this->position, this->name));
		}
};

#endif
