#ifndef IF_STATEMENT_H
#define IF_STATEMENT_H

#include "simplestatement.h"
#include "guardedstatement.h"

class IfStatement : public SimpleStatement {
	private:
		GuardedStatement *guardedStatement;

	public:
		IfStatement(SrcPosition *position, GuardedStatement *guardedStatement)
				: SimpleStatement(position), guardedStatement(guardedStatement) {}

		IfStatement(const IfStatement& ifStatement) : SimpleStatement(ifStatement.position) {
			*(this) = ifStatement;
		}

		virtual ~IfStatement() {
			delete this->guardedStatement;
		}

		GuardedStatement *getGuardedStatement() {
			return this->guardedStatement;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitIfStatement(this);
		}

		virtual Ast& clone() const {
			return *(new IfStatement(new SrcPosition(*(this->position)),
					 this->guardedStatement ? dynamic_cast<GuardedStatement*>(&(this->guardedStatement->clone())) : 0));
		}
};

#endif
