#ifndef MULTIPLE_ARRAY_REFERENCE_H
#define MULTIPLE_ARRAY_REFERENCE_H

#include "arrayreference.h"
#include "expression.h"

class MultipleArrayReference : public ArrayReference {
	private:
		ArrayReference *arrayReference;
		Expression *expression;

	public:
		MultipleArrayReference(SrcPosition *position, ArrayReference *arrayReference, Expression *expression)
				: ArrayReference(position), Ast(position), arrayReference(arrayReference), expression(expression) {}

		MultipleArrayReference(const MultipleArrayReference& multipleArrayReference) : ArrayReference(multipleArrayReference.position), Ast(position) {
			*(this) = multipleArrayReference;
		}

		virtual ~MultipleArrayReference() {
			delete this->arrayReference;
			delete this->expression;
		}

		ArrayReference *getArrayReference() {
			return this->arrayReference;
		}

		Expression *getExpression() {
			return this->expression;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitMultipleArrayReference(this);
		}

		virtual Ast& clone() const {
			return *(new MultipleArrayReference(new SrcPosition(*(this->position)),
					 this->arrayReference ? dynamic_cast<ArrayReference*>(&(this->arrayReference->clone())) : 0,
					 this->expression ? dynamic_cast<Expression*>(&(this->expression->clone())) : 0));
		}
};

#endif
