#include <typeinfo>
#include "program.h"
using namespace std;

Ast& Program::operator = (const Ast& ast) {
	const Program& program = dynamic_cast<const Program&>(ast);

	Ast::operator=(ast);
	this->import = program.import ? dynamic_cast<Import*>(&(program.import->clone())) : 0;
	this->behavior = program.behavior ? dynamic_cast<Behavior*>(&(program.behavior->clone())) : 0;
	this->message = program.message ? dynamic_cast<Message*>(&(program.message->clone())) : 0;
	this->process = program.process ? dynamic_cast<Process*>(&(program.process->clone())) : 0;

	return *(this);
}

bool Program::operator == (const Ast& ast) const {
	bool result = false;
	const Program& program = dynamic_cast<const Program&>(ast);

	if (typeid(ast) != typeid(Program))
		return false;

	if (this->import && this->behavior && this->message && this->process)
		result = (*(this->import) == *(program.import) &&
				   *(this->behavior) == *(program.behavior) &&
				   *(this->message) == *(program.message) &&
				   *(this->process) == *(program.process));

	return result;
}

