#include "sendstatement.h"

Ast& SendStatement::operator = (const Ast& ast) {
	const SendStatement& sendStatement = dynamic_cast<const SendStatement&>(ast);

	Statement::operator=(ast);

	this->msgId = sendStatement.msgId ? dynamic_cast<Identifier*>(&(sendStatement.msgId->clone())) : 0;
	this->addrId = sendStatement.addrId ? dynamic_cast<Identifier*>(&(sendStatement.addrId->clone())) : 0;
	this->tcp = sendStatement.tcp;

	return (*this);
}

bool SendStatement::operator == (const Ast& ast) const {
	const SendStatement& sendStatement = dynamic_cast<const SendStatement&>(ast);

	bool result = false;
	if(this->msgId && this->addrId) {
		result = (*(this->msgId) == *(sendStatement.msgId) &&
					 *(this->addrId) == *(sendStatement.addrId) &&
					 this->tcp == sendStatement.tcp);
	}

	return result && Statement::operator==(ast);
}
