#include <typeinfo>
#include "sequentialaction.h"
using namespace std;

Ast& SequentialAction::operator = (const Ast& ast) {
	const SequentialAction& sequentialAction = dynamic_cast<const SequentialAction&>(ast);

	Action::operator=(ast);
	this->action = sequentialAction.action ? dynamic_cast<Action*>(&(sequentialAction.action->clone())) : 0;
	this->simpleAction = sequentialAction.simpleAction ? dynamic_cast<SimpleAction*>(&(sequentialAction.simpleAction->clone())) : 0;

	return *(this);
}

bool SequentialAction::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialAction& sequentialAction = dynamic_cast<const SequentialAction&>(ast);

	if (typeid(ast) != typeid(SequentialAction))
		return false;

	if (this->action && this->simpleAction)
		result = (*(this->action) == *(sequentialAction.action) &&
				  *(this->simpleAction) == *(sequentialAction.simpleAction));

	return result && Action::operator==(ast);
}

