#ifndef SEQUENTIAL_ACTION_H
#define SEQUENTIAL_ACTION_H

#include "action.h"
#include "simpleaction.h"

class SequentialAction : public Action {
	private:
		Action *action;
		SimpleAction *simpleAction;


	public:
		SequentialAction(SrcPosition *position, Action *action, SimpleAction *simpleAction)
			: Action(position), action(action), simpleAction(simpleAction) {}

		SequentialAction(const SequentialAction& sequentialAction) : Action(sequentialAction.position) {
			*(this) = sequentialAction;
		}

		virtual ~SequentialAction() {
			delete this->action;
			delete this->simpleAction;
		}

		Action *getAction() {
			return this->action;
		}

		SimpleAction *getSimpleAction() {
			return this->simpleAction;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSequentialAction(this);
		}

		virtual Ast& clone() const {
			return *(new SequentialAction(new SrcPosition(*(this->position)),
					 this->action ? dynamic_cast<Action*>(&(this->action->clone())) : 0,
					 this->simpleAction ? dynamic_cast<SimpleAction*>(&(this->simpleAction->clone())) : 0));
		}
};

#endif
