#include <typeinfo>
#include "sequentialdeclaration.h"
using namespace std;

Ast& SequentialDeclaration::operator = (const Ast& ast) {
	const SequentialDeclaration& sequentialDeclaration = dynamic_cast<const SequentialDeclaration&>(ast);

	Declaration::operator=(ast);
	this->declaration = sequentialDeclaration.declaration ? dynamic_cast<Declaration*>(&(sequentialDeclaration.declaration->clone())) : 0;
	this->simpleDeclaration = sequentialDeclaration.simpleDeclaration ? dynamic_cast<SimpleDeclaration*>(&(sequentialDeclaration.simpleDeclaration->clone())) : 0;

	return *(this);
}

bool SequentialDeclaration::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialDeclaration& sequentialDeclaration = dynamic_cast<const SequentialDeclaration&>(ast);

	if (typeid(ast) != typeid(SequentialDeclaration))
		return false;

	if (this->declaration && this->simpleDeclaration)
		result = (*(this->declaration) == *(sequentialDeclaration.declaration) &&
				  *(this->simpleDeclaration) == *(sequentialDeclaration.simpleDeclaration));

	return result && Declaration::operator==(ast);
}

