#include <typeinfo>
#include "sequentialexpressionlist.h"
using namespace std;

Ast& SequentialExpressionList::operator = (const Ast& ast) {
	const SequentialExpressionList& sequentialExpressionList = dynamic_cast<const SequentialExpressionList&>(ast);

	ExpressionList::operator=(ast);
	this->expressionList = sequentialExpressionList.expressionList ? dynamic_cast<ExpressionList*>(&(sequentialExpressionList.expressionList->clone())) : 0;
	this->simpleExpressionList = sequentialExpressionList.simpleExpressionList ? dynamic_cast<SimpleExpressionList*>(&(sequentialExpressionList.simpleExpressionList->clone())) : 0;

	return *(this);
}

bool SequentialExpressionList::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialExpressionList& sequentialExpressionList = dynamic_cast<const SequentialExpressionList&>(ast);

	if (typeid(ast) != typeid(SequentialExpressionList))
		return false;

	if (this->expressionList && this->simpleExpressionList)
		result = (*(this->expressionList) == *(sequentialExpressionList.expressionList) &&
				  *(this->simpleExpressionList) == *(sequentialExpressionList.simpleExpressionList));

	return result && ExpressionList::operator==(ast);
}

