#include <typeinfo>
#include "sequentialfielddeclaration.h"
using namespace std;

Ast& SequentialFieldDeclaration::operator = (const Ast& ast) {
	const SequentialFieldDeclaration& sequentialFieldDeclaration = dynamic_cast<const SequentialFieldDeclaration&>(ast);

	FieldDeclaration::operator=(ast);
	this->fieldDeclaration = sequentialFieldDeclaration.fieldDeclaration ? dynamic_cast<FieldDeclaration*>(&(sequentialFieldDeclaration.fieldDeclaration->clone())) : 0;
	this->simpleFieldDeclaration = sequentialFieldDeclaration.simpleFieldDeclaration ? dynamic_cast<SimpleFieldDeclaration*>(&(sequentialFieldDeclaration.simpleFieldDeclaration->clone())) : 0;

	return *(this);
}

bool SequentialFieldDeclaration::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialFieldDeclaration& sequentialFieldDeclaration = dynamic_cast<const SequentialFieldDeclaration&>(ast);

	if (typeid(ast) != typeid(SequentialFieldDeclaration))
		return false;

	if (this->fieldDeclaration && this->simpleFieldDeclaration)
		result = (*(this->fieldDeclaration) == *(sequentialFieldDeclaration.fieldDeclaration) &&
				  *(this->simpleFieldDeclaration) == *(sequentialFieldDeclaration.simpleFieldDeclaration));

	return result && FieldDeclaration::operator==(ast);
}

