#ifndef SEQUENTIAL_FIELD_DECLARATION_H
#define SEQUENTIAL_FIELD_DECLARATION_H

#include "fielddeclaration.h"
#include "simplefielddeclaration.h"

class SequentialFieldDeclaration : public FieldDeclaration {
	private:
		FieldDeclaration *fieldDeclaration;
		SimpleFieldDeclaration *simpleFieldDeclaration;


	public:
		SequentialFieldDeclaration(SrcPosition *position, FieldDeclaration *fieldDeclaration, SimpleFieldDeclaration *simpleFieldDeclaration)
			: FieldDeclaration(position), fieldDeclaration(fieldDeclaration), simpleFieldDeclaration(simpleFieldDeclaration) {}

		SequentialFieldDeclaration(const SequentialFieldDeclaration& sequentialFieldDeclaration) : FieldDeclaration(sequentialFieldDeclaration.position) {
			*(this) = sequentialFieldDeclaration;
		}

		virtual ~SequentialFieldDeclaration() {
			delete this->fieldDeclaration;
			delete this->simpleFieldDeclaration;
		}

		FieldDeclaration *getFieldDeclaration() {
			return this->fieldDeclaration;
		}

		SimpleFieldDeclaration *getSimpleFieldDeclaration() {
			return this->simpleFieldDeclaration;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSequentialFieldDeclaration(this);
		}

		virtual Ast& clone() const {
			return *(new SequentialFieldDeclaration(new SrcPosition(*(this->position)),
					 this->fieldDeclaration ? dynamic_cast<FieldDeclaration*>(&(this->fieldDeclaration->clone())) : 0,
					 this->simpleFieldDeclaration ? dynamic_cast<SimpleFieldDeclaration*>(&(this->simpleFieldDeclaration->clone())) : 0));
		}
};

#endif
