#include <typeinfo>
#include "sequentialguardedstatement.h"
using namespace std;

Ast& SequentialGuardedStatement::operator = (const Ast& ast) {
	const SequentialGuardedStatement& sequentialGuardedStatement = dynamic_cast<const SequentialGuardedStatement&>(ast);

	GuardedStatement::operator=(ast);
	this->guardedStatement = sequentialGuardedStatement.guardedStatement ? dynamic_cast<GuardedStatement*>(&(sequentialGuardedStatement.guardedStatement->clone())) : 0;
	this->simpleGuardedStatement = sequentialGuardedStatement.simpleGuardedStatement ? dynamic_cast<SimpleGuardedStatement*>(&(sequentialGuardedStatement.simpleGuardedStatement->clone())) : 0;

	return *(this);
}

bool SequentialGuardedStatement::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialGuardedStatement& sequentialGuardedStatement = dynamic_cast<const SequentialGuardedStatement&>(ast);

	if (typeid(ast) != typeid(SequentialGuardedStatement))
		return false;

	if (this->guardedStatement && this->simpleGuardedStatement)
		result = (*(this->guardedStatement) == *(sequentialGuardedStatement.guardedStatement) &&
				  *(this->simpleGuardedStatement) == *(sequentialGuardedStatement.simpleGuardedStatement));

	return result && GuardedStatement::operator==(ast);
}

