#ifndef SEQUENTIAL_LEFT_SIDE_LIST_H
#define SEQUENTIAL_LEFT_SIDE_LIST_H

#include "leftsidelist.h"
#include "simpleleftsidelist.h"

class SequentialLeftSideList : public LeftSideList {
	private:
		LeftSideList *leftSideList;
		SimpleLeftSideList *simpleLeftSideList;


	public:
		SequentialLeftSideList(SrcPosition *position, LeftSideList *leftSideList, SimpleLeftSideList *simpleLeftSideList)
			: LeftSideList(position), leftSideList(leftSideList), simpleLeftSideList(simpleLeftSideList) {}

		SequentialLeftSideList(const SequentialLeftSideList& sequentialLeftSideList) : LeftSideList(sequentialLeftSideList.position) {
			*(this) = sequentialLeftSideList;
		}

		virtual ~SequentialLeftSideList() {
			delete this->leftSideList;
			delete this->simpleLeftSideList;
		}

		LeftSideList *getLeftSideList() {
			return this->leftSideList;
		}

		SimpleLeftSideList *getSimpleLeftSideList() {
			return this->simpleLeftSideList;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSequentialLeftSideList(this);
		}

		virtual Ast& clone() const {
			return *(new SequentialLeftSideList(new SrcPosition(*(this->position)),
					 this->leftSideList ? dynamic_cast<LeftSideList*>(&(this->leftSideList->clone())) : 0,
					 this->simpleLeftSideList ? dynamic_cast<SimpleLeftSideList*>(&(this->simpleLeftSideList->clone())) : 0));
		}
};

#endif
