#ifndef SEQUENTIAL_STATEMENT_H
#define SEQUENTIAL_STATEMENT_H

#include "statement.h"
#include "simplestatement.h"

class SequentialStatement : public Statement {
	private:
		Statement *statement;
		SimpleStatement *simpleStatement;


	public:
		SequentialStatement(SrcPosition *position, Statement *statement, SimpleStatement *simpleStatement)
			: Statement(position), statement(statement), simpleStatement(simpleStatement) {}

		SequentialStatement(const SequentialStatement& sequentialStatement) : Statement(sequentialStatement.position) {
			*(this) = sequentialStatement;
		}

		virtual ~SequentialStatement() {
			delete this->statement;
			delete this->simpleStatement;
		}

		Statement *getStatement() {
			return this->statement;
		}

		SimpleStatement *getSimpleStatement() {
			return this->simpleStatement;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSequentialStatement(this);
		}

		virtual Ast& clone() const {
			return *(new SequentialStatement(new SrcPosition(*(this->position)),
					 this->statement ? dynamic_cast<Statement*>(&(this->statement->clone())) : 0,
					 this->simpleStatement ? dynamic_cast<SimpleStatement*>(&(this->simpleStatement->clone())) : 0));
		}
};

#endif
