#include <typeinfo>
#include "simpleaction.h"
using namespace std;

Ast& SimpleAction::operator = (const Ast& ast) {
	const SimpleAction& simpleAction = dynamic_cast<const SimpleAction&>(ast);

	Action::operator=(ast);
	this->guard = simpleAction.guard ? dynamic_cast<Guard*>(&(simpleAction.guard->clone())) : 0;
	this->statement = simpleAction.statement ? dynamic_cast<Statement*>(&(simpleAction.statement->clone())) : 0;

	return *(this);
}

bool SimpleAction::operator == (const Ast& ast) const {
	bool result = false;
	const SimpleAction& simpleAction = dynamic_cast<const SimpleAction&>(ast);

	if (typeid(ast) != typeid(SimpleAction))
		return false;

	if (this->guard && this->statement)
		result = (*(this->guard) == *(simpleAction.guard) &&
				   *(this->statement) == *(simpleAction.statement));

	return result && Action::operator==(ast);
}

