#include <typeinfo>
#include "simplearrayreference.h"
using namespace std;

Ast& SimpleArrayReference::operator = (const Ast& ast) {
	const SimpleArrayReference& simpleArrayReference = dynamic_cast<const SimpleArrayReference&>(ast);

	ArrayReference::operator=(ast);
	this->identifier = simpleArrayReference.identifier ? dynamic_cast<Identifier*>(&(simpleArrayReference.identifier->clone())) : 0;
	this->expression = simpleArrayReference.expression ? dynamic_cast<Expression*>(&(simpleArrayReference.expression->clone())) : 0;

	return *(this);
}

bool SimpleArrayReference::operator == (const Ast& ast) const {
	bool result = false;
	const SimpleArrayReference& simpleArrayReference = dynamic_cast<const SimpleArrayReference&>(ast);

	if (typeid(ast) != typeid(SimpleArrayReference))
		return false;

	if (this->identifier && this->expression)
		result = (*(this->identifier) == *(simpleArrayReference.identifier) &&
				   *(this->expression) == *(simpleArrayReference.expression));

	return result && ArrayReference::operator==(ast);
}

