#include <typeinfo>
#include "simpledeclaration.h"
using namespace std;

Ast& SimpleDeclaration::operator = (const Ast& ast) {
	const SimpleDeclaration& simpleDeclaration = dynamic_cast<const SimpleDeclaration&>(ast);

	Declaration::operator=(ast);
	this->identifierList = this->identifierList ? dynamic_cast<IdentifierList*>(&(simpleDeclaration.identifierList->clone())) : 0;
	this->type = this->type ? dynamic_cast<Type*>(&(simpleDeclaration.type->clone())) : 0;
	this->expression = this->expression ? dynamic_cast<Expression*>(&(simpleDeclaration.expression->clone())) : 0;
	this->constant = simpleDeclaration.constant;

	return *(this);
}

bool SimpleDeclaration::operator == (const Ast& ast) const {
	bool result = false;
	const SimpleDeclaration& simpleDeclaration = dynamic_cast<const SimpleDeclaration&>(ast);

	if (typeid(ast) != typeid(SimpleDeclaration))
		return false;

	if (this->identifierList && this->type && this->expression)
		result = (*(this->identifierList) == *(simpleDeclaration.identifierList) &&
				   *(this->type) == *(simpleDeclaration.type) &&
				   *(this->expression) == *(simpleDeclaration.expression) &&
				   this->constant == simpleDeclaration.constant);

	return result && Declaration::operator==(ast);
}

