#ifndef SIMPLE_EXPRESSION_LIST_H
#define SIMPLE_EXPRESSION_LIST_H

#include "expressionlist.h"
#include "expression.h"

class SimpleExpressionList : public ExpressionList {
	private:
		Expression *expression;

	public:
		SimpleExpressionList(SrcPosition *position, Expression *expression)
			: ExpressionList(position), expression(expression) {}

		SimpleExpressionList(const SimpleExpressionList& simpleExpressionList) : ExpressionList(simpleExpressionList.position) {
			*(this) = simpleExpressionList;
		}

		virtual ~SimpleExpressionList() {
			delete this->expression;
		}

		Expression *getExpression() {
			return this->expression;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSimpleExpressionList(this);
		}

		virtual Ast& clone() const {
			return *(new SimpleExpressionList(new SrcPosition(*(this->position)),
					 this->expression ? dynamic_cast<Expression*>(&(this->expression->clone())) : 0));
		}
};

#endif
