#include <typeinfo>
#include "simplefielddeclaration.h"
using namespace std;

Ast& SimpleFieldDeclaration::operator = (const Ast& ast) {
	const SimpleFieldDeclaration& simpleFieldDeclaration = dynamic_cast<const SimpleFieldDeclaration&>(ast);

	FieldDeclaration::operator=(ast);
	this->identifier = simpleFieldDeclaration.identifier ? dynamic_cast<Identifier*>(&(simpleFieldDeclaration.identifier->clone())) : 0;
	this->fieldType = simpleFieldDeclaration.fieldType ? dynamic_cast<FieldType*>(&(simpleFieldDeclaration.fieldType->clone())) : 0;
	this->expression = simpleFieldDeclaration.expression ? dynamic_cast<Expression*>(&(simpleFieldDeclaration.expression->clone())) : 0;
	this->stringLiteral = simpleFieldDeclaration.stringLiteral ? dynamic_cast<StringLiteral*>(&(simpleFieldDeclaration.stringLiteral->clone())) : 0;

	return *(this);
}

bool SimpleFieldDeclaration::operator == (const Ast& ast) const {
	bool result = false;
	const SimpleFieldDeclaration& simpleFieldDeclaration = dynamic_cast<const SimpleFieldDeclaration&>(ast);

	if (typeid(ast) != typeid(SimpleFieldDeclaration))
		return false;

	if (this->identifier && this->fieldType && this->expression && this->stringLiteral)
		result = (*(this->identifier) == *(simpleFieldDeclaration.identifier) &&
				   *(this->fieldType) == *(simpleFieldDeclaration.fieldType) &&
				   *(this->expression) == *(simpleFieldDeclaration.expression) &&
				   *(this->stringLiteral) == *(simpleFieldDeclaration.stringLiteral));

	return result && FieldDeclaration::operator==(ast);
}

