#ifndef SIMPLE_IDENTIFIER_LIST_H
#define SIMPLE_IDENTIFIER_LIST_H

#include "identifierlist.h"
#include "identifier.h"

class SimpleIdentifierList : public IdentifierList {
	private:
		Identifier *identifier;

	public:
		SimpleIdentifierList(SrcPosition *position, Identifier *identifier)
			: IdentifierList(position), identifier(identifier) {}

		SimpleIdentifierList(const SimpleIdentifierList& simpleIdentifierList) : IdentifierList(simpleIdentifierList.position) {
			*(this) = simpleIdentifierList;
		}

		virtual ~SimpleIdentifierList() {
			delete this->identifier;
		}

		Identifier *getIdentifier() {
			return this->identifier;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSimpleIdentifierList(this);
		}

		virtual Ast& clone() const {
			return *(new SimpleIdentifierList(new SrcPosition(*(this->position)),
					 this->identifier ? dynamic_cast<Identifier*>(&(this->identifier->clone())) : 0));
		}
};

#endif
