#ifndef SIMPLE_IMPORT_H
#define SIMPLE_IMPORT_H

#include "import.h"
#include "stringliteral.h"

class SimpleImport : public Import {
	private:
		StringLiteral *stringLiteral;

	public:
		SimpleImport(SrcPosition *position, StringLiteral *stringLiteral)
			: Import(position), stringLiteral(stringLiteral) {}

		SimpleImport(const SimpleImport& simpleImport) : Import(simpleImport.position) {
			*(this) = simpleImport;
		}

		virtual ~SimpleImport() {
			delete this->stringLiteral;
		}

		StringLiteral *getStringLiteral() {
			return this->stringLiteral;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSimpleImport(this);
		}

		virtual Ast& clone() const {
			return *(new SimpleImport(new SrcPosition(*(this->position)),
					 this->stringLiteral ? dynamic_cast<StringLiteral*>(&(this->stringLiteral->clone())) : 0));
		}
};

#endif
