#include <typeinfo>
#include "simplemessage.h"
using namespace std;

Ast& SimpleMessage::operator = (const Ast& ast) {
	const SimpleMessage& simpleMessage = dynamic_cast<const SimpleMessage&>(ast);

	Message::operator=(ast);
	this->identifier = this->identifier ? dynamic_cast<Identifier*>(&(simpleMessage.identifier->clone())) : 0;
	this->fieldDeclaration = this->fieldDeclaration ? dynamic_cast<FieldDeclaration*>(&(simpleMessage.fieldDeclaration->clone())) : 0;
	this->handlerIn = this->handlerIn ? dynamic_cast<Identifier*>(&(simpleMessage.handlerIn->clone())) : 0;
	this->handlerOut = this->handlerOut ? dynamic_cast<Identifier*>(&(simpleMessage.handlerOut->clone())) : 0;
	this->external = simpleMessage.external;

	return *(this);
}

bool SimpleMessage::operator == (const Ast& ast) const {
	bool result = false;
	const SimpleMessage& simpleMessage = dynamic_cast<const SimpleMessage&>(ast);

	if (typeid(ast) != typeid(SimpleMessage))
		return false;

	if (this->identifier && this->fieldDeclaration && this->handlerIn && this->handlerOut)
		result = (*(this->identifier) == *(simpleMessage.identifier) &&
				   *(this->fieldDeclaration) == *(simpleMessage.fieldDeclaration)) &&
				   *(this->handlerIn) == *(simpleMessage.handlerIn) && 
				   *(this->handlerOut) == *(simpleMessage.handlerOut) && 
				   this->external == simpleMessage.external;

	return result && Message::operator==(ast);
}

