#ifndef START_STATEMENT_H
#define START_STATEMENT_H

#include "simplestatement.h"
#include "identifier.h"

class StartStatement : public SimpleStatement {
	private:
		Identifier *identifier;

	public:
		StartStatement(SrcPosition *position, Identifier *identifier)
				: SimpleStatement(position), identifier(identifier) {}

		StartStatement(const StartStatement& startStatement) : SimpleStatement(startStatement.position) {
			*(this) = startStatement;
		}

		virtual ~StartStatement() {
			delete this->identifier;
		}

		Identifier *getIdentifier() {
			return this->identifier;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitStartStatement(this);
		}

		virtual Ast& clone() const {
			return *(new StartStatement(new SrcPosition(*(this->position)),
					 this->identifier ? dynamic_cast<Identifier*>(&(this->identifier->clone())) : 0));
		}
};

#endif
